Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/HeuristicLab.Services.WebApp.Statistics-3.3.csproj
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/HeuristicLab.Services.WebApp.Statistics-3.3.csproj	(revision 12550)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/HeuristicLab.Services.WebApp.Statistics-3.3.csproj	(revision 12551)
@@ -79,8 +79,7 @@
       <HintPath>..\..\packages\Microsoft.Web.Infrastructure.1.0.0.0\lib\net40\Microsoft.Web.Infrastructure.dll</HintPath>
     </Reference>
-    <Reference Include="Newtonsoft.Json, Version=6.0.0.0, Culture=neutral, PublicKeyToken=30ad4fe6b2a6aeed, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\packages\Newtonsoft.Json.6.0.4\lib\net45\Newtonsoft.Json.dll</HintPath>
-      <Private>False</Private>
+    <Reference Include="Newtonsoft.Json, Version=7.0.0.0, Culture=neutral, PublicKeyToken=30ad4fe6b2a6aeed, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\packages\Newtonsoft.Json.7.0.1\lib\net45\Newtonsoft.Json.dll</HintPath>
     </Reference>
     <Reference Include="System" />
@@ -146,4 +145,5 @@
     <Compile Include="WebApi\DataTransfer\ClientPage.cs" />
     <Compile Include="WebApi\DataTransfer\ClientStatus.cs" />
+    <Compile Include="WebApi\DataTransfer\ExceptionPage.cs" />
     <Compile Include="WebApi\DataTransfer\Group.cs" />
     <Compile Include="WebApi\DataTransfer\GroupDetails.cs" />
@@ -154,7 +154,10 @@
     <Compile Include="WebApi\DataTransfer\JobPage.cs" />
     <Compile Include="WebApi\DataTransfer\Task.cs" />
+    <Compile Include="WebApi\DataTransfer\Exception.cs" />
     <Compile Include="WebApi\DataTransfer\TaskPage.cs" />
     <Compile Include="WebApi\DataTransfer\TaskStateCount.cs" />
     <Compile Include="WebApi\DataTransfer\User.cs" />
+    <Compile Include="WebApi\DataTransfer\UserDetails.cs" />
+    <Compile Include="WebApi\ExceptionController.cs" />
     <Compile Include="WebApi\GroupController.cs" />
     <Compile Include="WebApi\JavascriptUtils.cs" />
@@ -176,4 +179,10 @@
       <CopyToOutputDirectory>Always</CopyToOutputDirectory>
     </Content>
+    <Content Include="WebApp\exceptions\exceptionsCtrl.js">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </Content>
+    <Content Include="WebApp\exceptions\exceptionDetailsDialogCtrl.js">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </Content>
     <Content Include="WebApp\groups\details\groupDetailsCtrl.js">
       <CopyToOutputDirectory>Always</CopyToOutputDirectory>
@@ -192,4 +201,7 @@
     </Content>
     <Content Include="WebApp\services\clientService.js">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </Content>
+    <Content Include="WebApp\services\exceptionService.js">
       <CopyToOutputDirectory>Always</CopyToOutputDirectory>
     </Content>
@@ -242,4 +254,10 @@
       <CopyToOutputDirectory>Always</CopyToOutputDirectory>
     </Content>
+    <None Include="WebApp\exceptions\exceptions.cshtml">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </None>
+    <None Include="WebApp\exceptions\exceptionDetailsDialog.cshtml">
+      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
+    </None>
     <None Include="WebApp\groups\details\groupDetails.cshtml">
       <CopyToOutputDirectory>Always</CopyToOutputDirectory>
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/ClientController.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/ClientController.cs	(revision 12550)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/ClientController.cs	(revision 12551)
@@ -47,13 +47,13 @@
             .GroupBy(x => x.ClientId)
             .Select(x => new {
-              TotalIdleTime = (long)x.Sum(y => y.TotalTimeIdle),
-              TotalOfflineTime = (long)x.Sum(y => y.TotalTimeOffline),
-              TotalUnavailableTime = (long)x.Sum(y => y.TotalTimeUnavailable)
+              TotalIdleTime = x.Sum(y => y.IdleTime),
+              TotalOfflineTime = x.Sum(y => y.OfflineTime),
+              TotalUnavailableTime = x.Sum(y => y.UnavailableTime)
             }).FirstOrDefault();
           var taskTimeData = factTaskDao.GetByClientId(id)
             .GroupBy(x => x.LastClientId)
             .Select(x => new {
-              TotalCalculatingTime = (long)x.Sum(y => y.CalculatingTime),
-              TotalTransferringTime = (long)x.Sum(y => y.TransferTime)
+              TotalCalculatingTime = x.Sum(y => y.CalculatingTime),
+              TotalTransferringTime = x.Sum(y => y.TransferTime)
             }).FirstOrDefault();
           var startDate = factClientInfoDao.GetByClientId(id)
@@ -99,5 +99,12 @@
                                       State = x.Key.ToString(),
                                       Count = x.Count()
-                                    }).ToList()
+                                    }).ToList(),
+                    Users = factTaskDao.GetAll()
+                              .Where(x => x.LastClientId == id)
+                              .Select(x => new DT.User {
+                                Id = x.DimJob.UserId,
+                                Name = x.DimJob.UserName
+                              })
+                              .Distinct().ToList()
                   })
                   .FirstOrDefault();
@@ -127,5 +134,6 @@
                          State = clientInfo.SlaveState.ToString(),
                          GroupId = client.ResourceGroupId,
-                         GroupName = client.GroupName
+                         GroupName = client.GroupName,
+                         IsAllowedToCalculate = clientInfo.IsAllowedToCalculate
                        });
           return new DT.ClientPage {
@@ -212,5 +220,6 @@
                          State = clientInfo.SlaveState.ToString(),
                          GroupId = client.ResourceGroupId,
-                         GroupName = client.GroupName
+                         GroupName = client.GroupName,
+                         IsAllowedToCalculate = clientInfo.IsAllowedToCalculate
                        });
           return new DT.ClientPage {
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/Client.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/Client.cs	(revision 12550)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/Client.cs	(revision 12551)
@@ -35,4 +35,5 @@
     public Guid? GroupId { get; set; }
     public string GroupName { get; set; }
+    public bool IsAllowedToCalculate { get; set; }
   }
 }
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/ClientDetails.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/ClientDetails.cs	(revision 12550)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/ClientDetails.cs	(revision 12551)
@@ -43,4 +43,5 @@
     public long TotalTransferringTime { get; set; }
     public IEnumerable<TaskStateCount> TasksStates { get; set; }
+    public IEnumerable<User> Users { get; set; }
   }
 }
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/Group.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/Group.cs	(revision 12550)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/Group.cs	(revision 12551)
@@ -31,5 +31,6 @@
     public int UsedMemory { get; set; }
     public double CpuUtilization { get; set; }
-    public int Clients { get; set; }
+    public int TotalClients { get; set; }
+    public int OnlineClients { get; set; }
   }
 }
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/GroupDetails.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/GroupDetails.cs	(revision 12550)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/DataTransfer/GroupDetails.cs	(revision 12551)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Collections.Generic;
 
 namespace HeuristicLab.Services.WebApp.Statistics.WebApi.DataTransfer {
@@ -30,6 +31,14 @@
     public int TotalMemory { get; set; }
     public int UsedMemory { get; set; }
-    public double CpuUtilization { get; set; }
-    public int Clients { get; set; }
+    public double TotalCpuUtilization { get; set; }
+    public double ActiveCpuUtilization { get; set; }
+    public int TotalClients { get; set; }
+    public int OnlineClients { get; set; }
+    public long TotalUnavailableTime { get; set; }
+    public long TotalCalculatingTime { get; set; }
+    public long TotalIdleTime { get; set; }
+    public long TotalOfflineTime { get; set; }
+    public long TotalTransferringTime { get; set; }
+    public IEnumerable<TaskStateCount> TasksStates { get; set; }
   }
 }
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/GroupController.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/GroupController.cs	(revision 12550)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/GroupController.cs	(revision 12551)
@@ -38,5 +38,34 @@
         var dimClientDao = pm.DimClientDao;
         var factClientInfoDao = pm.FactClientInfoDao;
+        var factTaskDao = pm.FactTaskDao;
         return pm.UseTransaction(() => {
+          var clientTimeData = factClientInfoDao.GetAll()
+            .Join(dimClientDao.GetAll(), x => x.ClientId, y => y.Id, (x, y) => new {
+              y.ResourceGroupId,
+              x.IdleTime,
+              x.OfflineTime,
+              x.UnavailableTime
+            })
+            .Where(x => x.ResourceGroupId == id)
+            .GroupBy(x => x.ResourceGroupId)
+            .Select(x => new {
+              TotalIdleTime = x.Sum(y => y.IdleTime),
+              TotalOfflineTime = x.Sum(y => y.OfflineTime),
+              TotalUnavailableTime = x.Sum(y => y.UnavailableTime)
+            })
+            .FirstOrDefault();
+
+          var taskTimeData = factTaskDao.GetByGroupId(id)
+            .Select(x => new {
+              id,
+              x.CalculatingTime,
+              x.TransferTime
+            })
+            .GroupBy(x => x.id)
+            .Select(x => new {
+              CalculatingTime = x.Sum(y => y.CalculatingTime),
+              TransferTime = x.Sum(y => y.TransferTime)
+            })
+            .FirstOrDefault();
           return (from client in dimClientDao.GetActiveClients().Where(x => x.ResourceGroupId == id)
                   join info in factClientInfoDao.GetAll()
@@ -51,16 +80,30 @@
                     TotalMemory = clientInfo.TotalMemory,
                     UsedMemory = offline ? 0 : clientInfo.UsedMemory,
-                    CpuUtilization = offline ? 0 : clientInfo.CpuUtilization
+                    CpuUtilization = offline ? 0 : clientInfo.CpuUtilization,
+                    SlaveState = clientInfo.SlaveState
                   })
             .GroupBy(x => new { x.ResourceGroupId, x.GroupName })
             .Select(x => new DT.GroupDetails {
-              Id = x.Key.ResourceGroupId ?? default(Guid),
+              Id = id,
               Name = x.Key.GroupName,
-              Clients = x.Count(),
+              TotalClients = x.Count(),
+              OnlineClients = x.Count(y => y.SlaveState != DA.SlaveState.Offline),
               TotalCores = x.Sum(y => y.TotalCores),
               UsedCores = x.Sum(y => y.UsedCores),
               TotalMemory = x.Sum(y => y.TotalMemory),
               UsedMemory = x.Sum(y => y.UsedMemory),
-              CpuUtilization = x.Average(y => y.CpuUtilization)
+              TotalCpuUtilization = x.Average(y => (double?)y.CpuUtilization) ?? 0.0,
+              ActiveCpuUtilization = x.Where(y => y.SlaveState != DA.SlaveState.Offline).Average(y => (double?)y.CpuUtilization) ?? 0.0,
+              TotalUnavailableTime = clientTimeData != null ? clientTimeData.TotalUnavailableTime : 0,
+              TotalCalculatingTime = taskTimeData != null ? taskTimeData.CalculatingTime : 0,
+              TotalIdleTime = clientTimeData != null ? clientTimeData.TotalIdleTime : 0,
+              TotalOfflineTime = clientTimeData != null ? clientTimeData.TotalOfflineTime : 0,
+              TotalTransferringTime = taskTimeData != null ? taskTimeData.TransferTime : 0,
+              TasksStates = factTaskDao.GetByGroupId(id)
+                                    .GroupBy(y => y.TaskState)
+                                    .Select(y => new DT.TaskStateCount {
+                                      State = y.Key.ToString(),
+                                      Count = y.Count()
+                                    }).ToList()
             }).FirstOrDefault();
         });
@@ -83,13 +126,15 @@
                       TotalMemory = clientInfo.TotalMemory,
                       UsedMemory = offline ? 0 : clientInfo.UsedMemory,
-                      CpuUtilization = offline ? 0 : clientInfo.CpuUtilization
+                      CpuUtilization = offline ? 0 : clientInfo.CpuUtilization,
+                      SlaveState = clientInfo.SlaveState
                     }).GroupBy(x => x.ResourceGroupId).Select(x => new {
                       GroupId = x.Key,
-                      Count = x.Count(),
+                      TotalClients = x.Count(),
+                      OnlineClients = x.Count(y => y.SlaveState != DA.SlaveState.Offline),
                       TotalCores = x.Sum(y => y.TotalCores),
                       UsedCores = x.Sum(y => y.UsedCores),
                       TotalMemory = x.Sum(y => y.TotalMemory),
                       UsedMemory = x.Sum(y => y.UsedMemory),
-                      CpuUtilization = x.Average(y => y.CpuUtilization)
+                      CpuUtilization = x.Where(y => y.SlaveState != DA.SlaveState.Offline).Average(y => (double?)y.CpuUtilization) ?? 0.0
                     });
         var query = dimClientDao.GetAll()
@@ -108,5 +153,6 @@
               Id = group.Id,
               Name = group.Name,
-              Clients = info.Count,
+              TotalClients = info.TotalClients,
+              OnlineClients = info.OnlineClients,
               TotalCores = info.TotalCores,
               UsedCores = info.UsedCores,
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/TaskController.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/TaskController.cs	(revision 12550)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/TaskController.cs	(revision 12551)
@@ -102,5 +102,5 @@
 
     [HttpPost]
-    public DT.TaskPage GetTasksByClientId(Guid id, int page, int size, IEnumerable<string> states) {
+    public DT.TaskPage GetTasksByClientId(Guid id, int page, int size, IEnumerable<string> states, Guid userId = default(Guid)) {
       bool isAdministrator = User.IsInRole(HiveRoles.Administrator);
       using (var pm = PersistenceManager) {
@@ -108,7 +108,9 @@
         var dimClientDao = pm.DimClientDao;
         var factTaskDao = pm.FactTaskDao;
-
         return pm.UseTransaction(() => {
           var tasks = factTaskDao.GetByClientId(id).Where(x => states.Contains(x.TaskState.ToString()));
+          if (userId != Guid.Empty) {
+            tasks = tasks.Where(x => x.DimJob.UserId == userId);
+          }
           return new DT.TaskPage {
             TotalTasks = tasks.Count(),
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/UserController.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/UserController.cs	(revision 12550)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApi/UserController.cs	(revision 12551)
@@ -48,13 +48,20 @@
     }
 
-    public DT.User GetUser(Guid id) {
+    public DT.UserDetails GetUser(Guid id) {
       using (var pm = PersistenceManager) {
         var dimUserDao = pm.DimUserDao;
+        var factTaskDao = pm.FactTaskDao;
         return pm.UseTransaction(() => {
           var user = dimUserDao.GetById(id);
           if (user != null) {
-            return new DT.User {
+            return new DT.UserDetails {
               Id = user.UserId,
-              Name = user.Name
+              Name = user.Name,
+              TasksStates = factTaskDao.GetByUserId(id)
+                            .GroupBy(x => x.TaskState)
+                            .Select(x => new DT.TaskStateCount {
+                              State = x.Key.ToString(),
+                              Count = x.Count()
+                            }).ToList()
             };
           }
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/clients.cshtml
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/clients.cshtml	(revision 12550)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/clients.cshtml	(revision 12551)
@@ -3,19 +3,24 @@
 <header class="view-header">
     <ul class="nav nav-list nav-list-topbar pull-left">
-    <li>
-        <a ng-href="#/statistics/jobs">Jobs</a>
-    </li>
-    @if (Request.IsAuthenticated && User.IsInRole(HiveRoles.Administrator))
-    {
         <li>
-            <a ng-href="#/statistics/users">Users</a>
+            <a ng-href="#/statistics/jobs">Jobs</a>
         </li>
-    }
-    <li class="active">
-        <a ng-href="#/statistics/clients">Clients</a>
-    </li>
-    <li>
-        <a ng-href="#/statistics/groups">Groups</a>
-    </li>
+        @if (Request.IsAuthenticated && User.IsInRole(HiveRoles.Administrator))
+        {
+            <li>
+                <a ng-href="#/statistics/users">Users</a>
+            </li>
+        }
+        <li class="active">
+            <a ng-href="#/statistics/clients">Clients</a>
+        </li>
+        <li>
+            <a ng-href="#/statistics/groups">Groups</a>
+        </li>
+        @if (Request.IsAuthenticated && User.IsInRole(HiveRoles.Administrator)) {
+            <li>
+                <a ng-href="#/statistics/exceptions">Exceptions</a>
+            </li>
+        }
     </ul>
 </header>
@@ -37,4 +42,5 @@
                             <th>Cores</th>
                             <th>Cpu Utilization</th>
+                            <th>Memory</th>
                             <th>State</th>
                             <th></th>
@@ -50,4 +56,5 @@
                             <td>{{client.UsedCores}} / {{client.TotalCores}}</td>
                             <td>{{client.CpuUtilization | number: 2}} %</td>
+                            <td>{{client.UsedMemory | kbToGB}} / {{client.TotalMemory | kbToGB}} GB</td>
                             <td>{{client.State}}</td>
                             <td>
@@ -56,5 +63,5 @@
                         </tr>
                         <tr ng-hide="clientPage.Clients.length">
-                            <td colspan="6" class="text-center">No clients found!</td>
+                            <td colspan="7" class="text-center">No clients found!</td>
                         </tr>
                     </table>
@@ -82,4 +89,5 @@
                                 <th>Cores</th>
                                 <th>Cpu Utilization</th>
+                                <th>Memory</th>
                                 <th>State</th>
                                 <th></th>
@@ -91,4 +99,5 @@
                             <td>{{client.UsedCores}} / {{client.TotalCores}}</td>
                             <td>{{client.CpuUtilization | number: 2}} %</td>
+                            <td>{{client.UsedMemory | kbToGB}} / {{client.TotalMemory | kbToGB}} GB</td>
                             <td>{{client.State}}</td>
                             <td>
@@ -97,5 +106,5 @@
                         </tr>
                         <tr ng-hide="expiredClientPage.Clients.length">
-                            <td colspan="6" class="text-center">No expired clients found!</td>
+                            <td colspan="7" class="text-center">No expired clients found!</td>
                         </tr>
                     </table>
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/details/clientDetails.cshtml
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/details/clientDetails.cshtml	(revision 12550)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Statistics/3.3/WebApp/clients/details/clientDetails.cshtml	(revision 12551)
@@ -17,4 +17,9 @@
             <a ng-href="#/statistics/groups">Groups</a>
         </li>
+        @if (Request.IsAuthenticated && User.IsInRole(HiveRoles.Administrator)) {
+            <li>
+                <a ng-href="#/statistics/exceptions">Exceptions</a>
+            </li>
+        }
     </ul>
 </header>
@@ -46,9 +51,9 @@
                                 <tr>
                                     <td class="text-left">Up Time:</td>
-                                    <td>{{client.UpTime}}</td>
+                                    <td>{{client.UpTime | toTimespan}}</td>
                                 </tr>
                                 <tr>
                                     <td class="text-left">Last Update:</td>
-                                    <td>{{client.LastUpdate}}</td>
+                                    <td>{{client.LastUpdate | toDate}}</td>
                                 </tr>
                             </table>
@@ -58,21 +63,21 @@
                                 <tr>
                                     <td class="text-left">Total Unavailable Time:</td>
-                                    <td class="text-right">{{client.TotalUnavailableTime}}</td>
+                                    <td class="text-right">{{client.TotalUnavailableTime | toTimespan}}</td>
                                 </tr>
                                 <tr>
                                     <td class="text-left">Total Calculating Time:</td>
-                                    <td class="text-right">{{client.TotalCalculatingTime}}</td>
+                                    <td class="text-right">{{client.TotalCalculatingTime | toTimespan}}</td>
                                 </tr>
                                 <tr>
                                     <td class="text-left">Total Idle Time:</td>
-                                    <td class="text-right">{{client.TotalIdleTime}}</td>
+                                    <td class="text-right">{{client.TotalIdleTime | toTimespan}}</td>
                                 </tr>
                                 <tr>
                                     <td class="text-left">Total Transferring Time:</td>
-                                    <td class="text-right">{{client.TotalTransferringTime}}</td>
+                                    <td class="text-right">{{client.TotalTransferringTime | toTimespan}}</td>
                                 </tr>
                                 <tr>
                                     <td class="text-left">Total Offline Time:</td>
-                                    <td class="text-right">{{client.TotalOfflineTime}}</td>
+                                    <td class="text-right">{{client.TotalOfflineTime | toTimespan}}</td>
                                 </tr>
                             </table>
@@ -137,4 +142,14 @@
                         <knob knob-data="knobData.cpu" knob-options="knobOptions"></knob>
                     </div>
+                    <table class="table table-no-border table-condensed table-auto-width table-content">
+                        <tr>
+                            <td class="text-left">&nbsp;</td>
+                            <td class="text-right">&nbsp;</td>
+                        </tr>
+                        <tr>
+                            <td class="text-left">&nbsp;</td>
+                            <td class="text-right">&nbsp;</td>
+                        </tr>
+                    </table>
                 </div>
             </div>
@@ -153,9 +168,9 @@
                         <tr>
                             <td class="text-left">Total:</td>
-                            <td class="text-right">{{client.TotalMemory | number}} GB</td>
+                            <td class="text-right">{{client.TotalMemory | kbToGB}} GB</td>
                         </tr>
                         <tr>
                             <td class="text-left">Used:</td>
-                            <td class="text-right">{{client.UsedMemory | number}} GB</td>
+                            <td class="text-right">{{client.UsedMemory | kbToGB}} GB</td>
                         </tr>
                     </table>
@@ -163,5 +178,4 @@
             </div>
         </div>
-
     </div>
 </div>
@@ -169,5 +183,5 @@
 <div id="tasks-filter" class="default-filter-header text-center">
     <form class="form-inline">
-        <div class="form-group">
+        <div class="form-group" style="margin-left: 5px; margin-right: 5px;">
             <div class="btn-group" data-toggle="buttons">
                 <label class="btn btn-default" ng-class="{active: state.Selected}" ng-repeat="state in states"
@@ -175,4 +189,22 @@
                     <input type="checkbox" autocomplete="off" checked> {{state.State}}
                 </label>
+            </div>
+        </div>
+        <div class="form-group" style="margin-left: 5px; margin-right: 5px;">
+            <div class="btn-group" dropdown dropdown-append-to-body>
+                <button type="button" class="btn btn-default dropdown-toggle" dropdown-toggle>
+                    {{curUserName}} <span class="caret"></span>
+                </button>
+                <ul class="dropdown-menu" role="menu">
+                    <li>
+                        <a ng-href="#/statistics/clients/{{client.Id}}"
+                           ng-click="userChanged('00000000-0000-0000-0000-000000000000', 'All Users')">All Users</a>
+                    </li>
+                    <li class="divider"></li>
+                    <li ng-repeat="user in client.Users">
+                        <a ng-href="#/statistics/clients/{{client.Id}}"
+                           ng-click="userChanged(user.Id, user.Name)">{{user.Name}}</a>
+                    </li>
+                </ul>
             </div>
         </div>
@@ -210,15 +242,17 @@
                              </tr>
                          }
-                         <tr>
-                             <td>Start Time:</td>
-                             <td class="text-right">{{task.StartTime}}</td>
-                         </tr>
-                         <tr>
-                             <td>End Time:</td>
-                             <td class="text-right">{{task.EndTime}}</td>
-                         </tr>
+                        <tr>
+                            <td>Start Time:</td>
+                            <td ng-show="task.StartTime" class="text-right">{{task.StartTime | toDate}}</td>
+                            <td ng-hide="task.StartTime" class="text-right">Not started</td>
+                        </tr>
+                        <tr>
+                            <td>End Time:</td>
+                            <td ng-show="task.EndTime" class="text-right">{{task.EndTime | toDate}}</td>
+                            <td ng-hide="task.EndTime" class="text-right">Not finished</td>
+                        </tr>
                          <tr>
                              <td>Calculating Time:</td>
-                             <td class="text-right">{{task.CalculatingTime}}</td>
+                             <td class="text-right">{{task.CalculatingTime | toTimespan}}</td>
                          </tr>
                          @if (Request.IsAuthenticated && User.IsInRole(HiveRoles.Administrator))
